<template>
  <span :style="style">
    <svg v-if="name === 'log_in'" aria-hidden="true" focusable="false" data-prefix="far" data-icon="sign-in-alt" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-sign-in-alt fa-w-16 fa-2x"><path fill="currentColor" d="M144 112v51.6H48c-26.5 0-48 21.5-48 48v88.6c0 26.5 21.5 48 48 48h96v51.6c0 42.6 51.7 64.2 81.9 33.9l144-143.9c18.7-18.7 18.7-49.1 0-67.9l-144-144C195.8 48 144 69.3 144 112zm192 144L192 400v-99.7H48v-88.6h144V112l144 144zm80 192h-84c-6.6 0-12-5.4-12-12v-24c0-6.6 5.4-12 12-12h84c26.5 0 48-21.5 48-48V160c0-26.5-21.5-48-48-48h-84c-6.6 0-12-5.4-12-12V76c0-6.6 5.4-12 12-12h84c53 0 96 43 96 96v192c0 53-43 96-96 96z" class=""></path></svg>

    <svg v-if="name === 'log_out'" aria-hidden="true" focusable="false" data-prefix="far" data-icon="sign-out-alt" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-sign-out-alt fa-w-16 fa-2x"><path fill="currentColor" d="M272 112v51.6h-96c-26.5 0-48 21.5-48 48v88.6c0 26.5 21.5 48 48 48h96v51.6c0 42.6 51.7 64.2 81.9 33.9l144-143.9c18.7-18.7 18.7-49.1 0-67.9l-144-144C323.8 48 272 69.3 272 112zm192 144L320 400v-99.7H176v-88.6h144V112l144 144zM96 64h84c6.6 0 12 5.4 12 12v24c0 6.6-5.4 12-12 12H96c-26.5 0-48 21.5-48 48v192c0 26.5 21.5 48 48 48h84c6.6 0 12 5.4 12 12v24c0 6.6-5.4 12-12 12H96c-53 0-96-43-96-96V160c0-53 43-96 96-96z" class=""></path></svg>
  </span>
</template>

<script>
export default {
  name: 'icon',
  props: ['name', 'color', 'hoverColor'],
  computed: {
    style () {
      return { '--color': this.parsed_color, '--hover-color': this.parsed_hover_color }
    },
    parsed_color () {
      return this.parse_color(this.color)
    },
    parsed_hover_color () {
      return this.parse_color(this.hoverColor)
    }
  },
  methods: {
    parse_color (colorInput) {
      if (colorInput && colorInput[0] === '-') {
        return `var(${colorInput})`
      } else {
        return colorInput
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.svg-inline--fa {
  height: 25px;
  color: var(--color);

  &:hover {
    color: var(--hover-color);
  }
}
</style>
